<script lang="ts">
import Vue from 'vue';
import { IsMobileMixin } from '../../mixins';

export default Vue.extend({
  name: 'DevExCarousel',
  mixins: [IsMobileMixin],
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
  data() {
    return {
      visibleCaseStudy: 0,
    };
  },
  computed: {
    isArrowed() {
      return this.data?.customFields?.variant === 'arrowed';
    },
    isSolutions() {
      return this.data?.customFields?.styling === 'solutions';
    },
    isIndustry() {
      return this.data?.customFields?.styling === 'industry';
    },
    mainColumnCount() {
      if (this.isArrowed || this.isSolutions) {
        return 9;
      }
      return 8;
    },
  },
  methods: {
    selectNewSlide(index: number) {
      if (index < 0) {
        this.visibleCaseStudy = this.data.card.length - 1;
        return;
      }
      if (index >= this.data.card.length) {
        this.visibleCaseStudy = 0;
        return;
      }
      this.visibleCaseStudy = index;
    },
  },
});
</script>

<template>
  <section
    :id="data.customFields?.id"
    class="devex-carousel"
    :class="{
      'devex-carousel--solutions': isSolutions,
      'devex-carousel--arrowed': isArrowed,
      'devex-carousel--purple-background': data.customFields?.purple_background,
    }"
    aria-roledescription="carousel"
    aria-label="Case Studies Carousel"
  >
    <SlpContainer class="wrapper">
      <div class="header-wrapper">
        <SlpTypography
          v-if="data.header"
          variant="heading2-bold"
          tag="h3"
          class="slp-mb-32 carousel-header"
          >{{ data.header }}</SlpTypography
        >
        <div v-if="isSolutions" class="arrow-btns">
          <SlpButton
            class="arrow-btns__btn"
            variant="icon"
            aria-label="Previous case study"
            @click.native="selectNewSlide(visibleCaseStudy - 1)"
            ><SlpIcon
              variant="product"
              name="chevron-lg-left"
              slp-color="color-surface-500"
          /></SlpButton>
          <SlpButton
            class="arrow-btns__btn"
            variant="icon"
            aria-label="Next case study"
            @click.native="selectNewSlide(visibleCaseStudy + 1)"
            ><SlpIcon
              variant="product"
              name="chevron-lg-right"
              slp-color="color-surface-500"
          /></SlpButton>
        </div>
      </div>
      <div v-if="!isArrowed && !isSolutions">
        <div ref="scroll" class="logos">
          <button
            v-for="(logo, index) in data.card"
            :key="index"
            type="button"
            :aria-label="`Select ${logo.fields.componentName} case study`"
            :tabindex="index === visibleCaseStudy ? '-1' : 0"
            class="logo"
            :class="index === visibleCaseStudy ? 'active' : ''"
            :aria-selected="index === visibleCaseStudy"
            @click="selectNewSlide(index)"
          >
            <img
              :src="logo?.fields?.image?.fields?.file?.url"
              alt=""
              aria-label=""
            />
          </button>
        </div>
      </div>
      <div class="case-studies">
        <div :key="visibleCaseStudy" class="case-studies__card">
          <SlpRow
            class="card-row"
            :class="{
              'card-row--arrowed': isArrowed,
              'card-row--solutions': isSolutions,
              'card-row--purple-background':
                data.customFields?.purple_background,
            }"
            aria-roledescription="slide"
            :aria-label="`${visibleCaseStudy} of ${data.card.length}`"
          >
            <SlpColumn
              :cols="mainColumnCount"
              class="content"
              :class="{ content__arrowed: isArrowed || isSolutions }"
            >
              <figure class="text-block">
                <div
                  v-if="data.card[visibleCaseStudy].fields.description"
                  class="quote"
                >
                  <SlpIcon variant="marketing" name="quote" size="md" />
                  <div
                    class="quote-text"
                    v-html="
                      $md.render(data.card[visibleCaseStudy].fields.description)
                    "
                  ></div>
                  <div class="quote-author">
                    <img
                      v-if="data.card[visibleCaseStudy].fields.contentArea"
                      class="quote-headshot"
                      :src="
                        data.card[visibleCaseStudy].fields?.contentArea[0]
                          ?.fields?.image?.fields?.file?.url
                      "
                      :alt="
                        data.card[visibleCaseStudy].fields?.contentArea[0]
                          .fields?.altText
                      "
                    />
                    <div>
                      <SlpTypography variant="body2-bold" tag="p">{{
                        data.card[visibleCaseStudy].fields?.title
                      }}</SlpTypography>
                      <SlpTypography variant="body2" tag="p">
                        {{ data.card[visibleCaseStudy].fields?.subtitle }}
                      </SlpTypography>
                      <img
                        v-if="isSolutions"
                        class="solutions-logo"
                        :src="
                          data.card[visibleCaseStudy]?.fields.image?.fields
                            ?.file?.url
                        "
                        :alt="
                          data.card[visibleCaseStudy]?.fields.image?.fields
                            ?.file?.fileName
                        "
                        aria-label="logo"
                      />
                    </div>
                  </div>
                </div>
              </figure>
              <div v-if="isArrowed && !isSolutions" class="bottom-row">
                <SlpButton
                  v-show="data.card[visibleCaseStudy].fields.button"
                  variant="tertiary"
                  :href="
                    data.card[visibleCaseStudy].fields.button.fields.externalUrl
                  "
                  :data-ga-name="
                    data.card[visibleCaseStudy].fields.button.fields.dataGaName
                  "
                  :data-ga-location="
                    data.card[visibleCaseStudy].fields.button.fields
                      .dataGaLocation
                  "
                  >{{ data.card[visibleCaseStudy].fields.button.fields.text }}
                  <SlpIcon variant="product" name="chevron-lg-right"
                /></SlpButton>
                <div v-if="isArrowed" class="arrow-btns">
                  <SlpButton
                    class="arrow-btns__btn"
                    variant="icon"
                    aria-label="Previous case study"
                    @click.native="selectNewSlide(visibleCaseStudy - 1)"
                    ><SlpIcon
                      variant="product"
                      name="chevron-lg-left"
                      slp-color="color-surface-500"
                  /></SlpButton>
                  <SlpButton
                    class="arrow-btns__btn"
                    variant="icon"
                    aria-label="Next case study"
                    @click.native="selectNewSlide(visibleCaseStudy + 1)"
                    ><SlpIcon
                      variant="product"
                      name="chevron-lg-right"
                      slp-color="color-surface-500"
                  /></SlpButton>
                </div>
              </div>
            </SlpColumn>
            <SlpColumn
              v-if="isArrowed || !isSolutions"
              :cols="3"
              class="carousel-stats carousel-stats--arrowed"
            >
              <img
                :src="
                  data.card[visibleCaseStudy]?.fields.image?.fields?.file?.url
                "
                :alt="
                  data.card[visibleCaseStudy]?.fields.image?.fields?.file
                    ?.fileName
                "
                aria-label="logo"
              />
            </SlpColumn>
            <SlpColumn
              v-else-if="isSolutions"
              :cols="3"
              class="carousel-stats carousel-stats--solutions"
            >
              <div
                v-for="(stat, index) in data.card[visibleCaseStudy].fields
                  ?.customFields?.stats"
                :key="index"
              >
                <SlpTypography
                  variant="heading3-bold"
                  tag="h3"
                  class="slp-pt-24 purple-text"
                >
                  {{ stat?.number }}
                </SlpTypography>
                <SlpTypography
                  variant="body2"
                  tag="p"
                  class="slp-pb-24 slp-color-text-200"
                >
                  {{ stat?.text }}
                </SlpTypography>
              </div>
            </SlpColumn>
            <SlpColumn v-else :cols="4" class="carousel-stats">
              <div
                v-for="(stat, index) in data.card[visibleCaseStudy].fields
                  ?.customFields?.stats"
                :key="index"
              >
                <SlpTypography
                  variant="heading3-bold"
                  tag="h3"
                  class="slp-pt-24 purple-text"
                >
                  {{ stat?.number }}
                </SlpTypography>
                <SlpTypography
                  variant="body2"
                  tag="p"
                  class="slp-pb-24 slp-color-text-200"
                >
                  {{ stat?.text }}
                </SlpTypography>
              </div>
            </SlpColumn>
            <div v-if="!isArrowed && isSolutions" class="bottom-row">
              <SlpButton
                v-show="data.card[visibleCaseStudy].fields.button"
                variant="tertiary"
                :href="
                  data.card[visibleCaseStudy].fields.button.fields.externalUrl
                "
                :data-ga-name="
                  data.card[visibleCaseStudy].fields.button.fields.dataGaName
                "
                :data-ga-location="
                  data.card[visibleCaseStudy].fields.button.fields
                    .dataGaLocation
                "
                >{{ data.card[visibleCaseStudy].fields.button.fields.text }}
                <SlpIcon variant="product" name="chevron-lg-right"
              /></SlpButton>
            </div>
          </SlpRow>
        </div>
      </div>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.devex-carousel {
  padding: 120px 0;
  min-width: 100%;
  position: relative;

  .header-wrapper {
    width: 100%;
    display: flex;
    justify-content: space-between;
    .arrow-btns {
      display: flex;
      gap: 24px;
      align-items: flex-end;
      padding-bottom: 24px;
      @media (min-width: $breakpoint-lg) {
        margin-left: auto;
      }
      &__btn {
        justify-content: center;
        border-radius: 120px;
        border: 1px solid $color-surface-900;
        padding: 8px;
        height: 40px;
        width: 40px;

        :deep(.slp-icon) {
          transform: none !important;
        }
        background: white;

        &:hover {
          background-color: $color-surface-800;
        }
      }
    }
  }

  &--arrowed {
    padding: $spacing-32 0 120px 0;
    background: linear-gradient(
        to bottom,
        $color-surface-700 50%,
        transparent 50%,
        transparent 100%
      ),
      linear-gradient(to right, #fed5db, #d7c1f2);
    background-size: 100% 100%;
  }

  &--solutions {
    padding: $spacing-32 0 120px 0;
    background: linear-gradient(to top, #ffffff 65%, transparent 35%, #fff),
      linear-gradient(to left, #fed5db, #d7c1f2);
    background-size: 100% 100%;

    .case-studies {
      &__card {
        background-color: white;
        .content {
          background-color: transparent;
        }
      }
    }
    @media (max-width: $breakpoint-md) {
      padding-bottom: 0;
    }
  }
  &--purple-background {
    padding-top: 120px;
    background: none;
  }
}

.cta-container {
  display: flex;
  flex-direction: column;
  align-items: flex-start;
  .logos .logo img {
    max-width: 150px;
  }

  .cta {
    margin-bottom: $spacing-16;
    text-align: left;
  }
  @media (min-width: $breakpoint-lg) {
    flex-direction: row;
    justify-content: space-between;
    align-items: center;
  }
}
.wrapper {
  @media (max-width: $breakpoint-md) {
    padding: 0 0 $spacing-48;
  }
}

.logos {
  display: flex;
  align-items: center;
  @media (max-width: $breakpoint-md) {
    overflow-x: scroll;
    -ms-overflow-style: none; /* Internet Explorer 10+ */
    scrollbar-width: none; /* Firefox */
    margin: 0 $spacing-16;
    align-items: end;

    &::-webkit-scrollbar {
      display: none; /* Safari and Chrome */
    }
  }
}

.logo {
  min-height: 120px;
  width: 100%;
  border: none;
  border-top: 3px solid transparent;

  cursor: pointer;

  @media (max-width: $breakpoint-md) {
    flex: 0 0 80px;
    aspect-ratio: 3/2;
    object-fit: contain;
  }

  &.active {
    border-top: 3px solid $color-text-link-100;
    background: $color-surface-800;
  }

  img {
    margin: $spacing-32;
    -webkit-transform: translate3d(0, 0, 0);
    transform: translate3d(0, 0, 0);
    max-width: 140px;
    max-height: 45px;
    @media (max-width: $breakpoint-md) {
      margin: 0;
    }
  }
}

.case-studies {
  @media (max-width: $breakpoint-md) {
    margin: 0 $spacing-16;
  }

  .quote-text {
    line-height: 32px;
    font-size: 24px;
    margin-top: $spacing-8;
    margin-bottom: $spacing-24;
  }

  &__card {
    height: 100%;
    display: flex;
    position: relative;
    flex-direction: column;
    align-items: flex-start;
    isolation: isolate;
    background: $color-surface-800;
    will-change: contents;
    border-radius: 0px 0px 100px 4px;

    :deep(strong) {
      font-weight: $font-weight-bold;
    }

    :deep(.highlighted-text) {
      font-weight: $font-weight-bold;
      background: $color-surface-950;
    }
  }

  .content {
    background: $color-surface-800;
    padding: $spacing-64 $spacing-32 $spacing-64 $spacing-64;
    display: flex;
    border-radius: 0px 0px 100px 4px;

    flex-direction: column;

    @media (max-width: $breakpoint-md) {
      margin: $spacing-32;
      padding: $spacing-32 0;
      border-bottom: 1px solid $color-surface-400;
    }

    &__arrowed {
      margin-top: $spacing-32;
      padding: 0 0 0 $spacing-32;
      border-left: 1px solid $color-surface-400;

      @media (max-width: $breakpoint-md) {
        margin: 0;
        padding: $spacing-16 0;
        border: none;
        border-radius: 0 $spacing-16 0 0;
      }
    }

    .quote-author {
      display: flex;
      flex-direction: row;
      align-items: center;
      .solutions-logo {
        margin: 16px 0;
      }

      img {
        height: 80px;
        margin-right: $spacing-16;
        width: 80px;
        object-fit: cover;
        border-radius: 8px 8px 32px 8px;
      }
    }

    span {
      display: block;
    }
  }

  .carousel-stats {
    padding: 0 $spacing-64 0 $spacing-32;
    border-left: 1px solid $color-surface-400;
    margin: $spacing-32 0;

    @media (max-width: $breakpoint-md) {
      border-left: unset;
      padding: $spacing-32;
      margin: 0;
    }

    &--arrowed {
      padding: 0 $spacing-32 0 0;
      display: flex;
      justify-content: center;
      align-items: flex-start;
      border-left: none;

      @media (max-width: $breakpoint-md) {
        border: none;
      }

      img {
        max-width: 140px;
        max-height: 95px;
        padding-top: $spacing-24;

        @media (max-width: $breakpoint-md) {
          margin: 0;
        }
      }
    }

    &--solutions {
      border-left: none;
      padding: 0 0 0 64px;

      @media (max-width: $breakpoint-md) {
        padding-left: 0;
      }

      h3.purple-text {
        color: $color-text-300;
      }
    }

    .purple-text {
      color: $color-text-link-100;
    }
  }
}

.card-row {
  align-items: center;
  @media (min-width: $breakpoint-lg) {
    min-height: 372px;
  }

  &--arrowed {
    height: 100%;
    width: 100%;
    flex-direction: column-reverse;
    padding: $spacing-32 $spacing-16 $spacing-48 $spacing-32;
    border-radius: 4px 4px 100px 4px;

    @media (min-width: $breakpoint-lg) {
      flex-direction: row-reverse;
      align-items: flex-start;
      padding: $spacing-64;
    }
  }

  &--solutions {
    border: 1px solid $color-surface-200;
    border-radius: 4px 4px 100px 4px;
    padding: 64px;
    padding-bottom: 48px;
    align-items: flex-start;

    &:deep(.highlighted-text) {
      font-weight: $font-weight-bold;
      background: transparent;
    }

    .content,
    .carousel-stats,
    .bottom-row {
      opacity: 0;
      animation-name: opacity;
      animation-duration: 1.5s;
      animation-fill-mode: forwards;
    }

    .content {
      border-left: none;
      padding: 0;
      margin: 0;

      .quote-author img {
        width: initial;
        height: 36px;
        margin-top: 4px;
        border-radius: 0;
        max-width: 170px;
        object-fit: contain;
      }
    }

    .bottom-row {
      width: 100%;
    }

    .quote-headshot {
      display: none;
    }
  }
  &--purple-background {
    background: $color-surface-800;
  }
}

.bottom-row {
  display: flex;
  justify-content: space-between;

  .arrow-btns {
    display: flex;

    &__btn {
      margin: 0;
      padding: 11px;
      min-width: 0;

      :deep(.slp-icon) {
        transform: none !important;
      }

      &:hover {
        background-color: $color-surface-900;
      }
    }
  }

  @media (max-width: $breakpoint-md) {
    flex-wrap: wrap;
  }
}

.text-block {
  flex-basis: 100%;
}

@keyframes opacity {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}
.carousel-header {
  @media (min-width: $breakpoint-lg) {
    max-width: 70%;
  }
}
</style>
